/*
Copyright (c) 2018 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


int clip_for_rect(int *start, int *amount, int max);
int utf8_encode_string
    (const uint32_t* wstr,size_t wlen, uint8_t *dst, size_t *dlen);
int utf8_decode_string
  (const uint8_t *input, size_t ilen, uint32_t *output, size_t *olen);
uint32_t utf8_decode_single_char(char *src);
void utf8_encode_single_char(uint32_t wide, char *dst);

#ifdef UTIL_IMAX2
static int imax2(int a,int b) { return a>b?a:b; }
#endif
#ifdef UTIL_IMIN2
static int imin2(int a,int b) { return a<b?a:b; }
#endif
#ifdef UTIL_UMIN2
static unsigned int umin2(unsigned int a,unsigned int b) { return a<b?a:b; }
#endif
#ifdef UTIL_UMAX2
static unsigned int umax2(unsigned int a,unsigned int b) { return a>b?a:b; }
#endif

size_t wstrlen(uint32_t *str);
